(function () {
var ASPxClientLoadingPanel = ASPx.CreateClass(ASPxClientControl, {
 constructor: function (name) {
  this.constructor.prototype.constructor.call(this, name);
  this.containerElementID = "";
  this.containerElement = null;
  this.horizontalOffset = 0;
  this.verticalOffset = 0;
  this.isTextEmpty = false;
  this.showImage = true;
  this.shown = false;
  this.currentoffsetElement = null;
  this.currentX = null;
  this.currentY = null;
 },
 Initialize: function () {
  if(this.containerElementID != "")
   this.containerElement = ASPx.GetElementById(this.containerElementID);
  ASPxClientControl.prototype.Initialize.call(this);
 },
 SetCurrentShowArguments: function (offsetElement, x, y) {
  if(offsetElement == null)
   offsetElement = this.containerElement;
  if(offsetElement && !ASPx.IsValidElement(offsetElement))
   offsetElement = ASPx.GetElementById(offsetElement.id);
  if(offsetElement == null)
   offsetElement = document.body;
  this.SetCurrentoffsetElement(offsetElement);
  this.currentX = x;
  this.currentY = y;
 },
 SetCurrentoffsetElement: function(offsetElement) {
  this.ChangeTabIndexesBehindLoadingDiv(true);
  this.currentoffsetElement = offsetElement;
  delete ASPxClientControl.documentDropDownMouseDownLocked;
 },
 GetCurrentoffsetElement: function() {
  return this.currentoffsetElement;
 },
 ResetCurrentShowArguments: function () {
  this.SetCurrentoffsetElement(null);
  this.currentX = null;
  this.currentY = null;
 },
 SetLoadingPanelPosAndSize: function () {
  var element = this.GetMainElement();
  this.SetLoadingPanelLocation(this.GetCurrentoffsetElement(), element, this.currentX, this.currentY, this.horizontalOffset, this.verticalOffset);
 },
 SetLoadingDivPosAndSize: function () {
  var element = this.GetLoadingDiv();
  if(element != null) {
   ASPx.SetElementDisplay(element, true);
   var offsetElement = this.GetCurrentoffsetElement();
   this.SetLoadingDivBounds(offsetElement, element);
   var activeElement = document.activeElement;
   if(offsetElement.contains(activeElement) &&
    !(ASPx.Browser.IE && ASPx.Browser.Version < 11 && activeElement === document.body) && !!activeElement.blur)
    activeElement.blur();
   this.ChangeTabIndexesBehindLoadingDiv(false);
   if(offsetElement === document.body)
    ASPxClientControl.documentDropDownMouseDownLocked = true;
  }
 },
 ShowInternal: function (offsetElement, x, y) {
  this.SetCurrentShowArguments(offsetElement, x, y);
  var element = this.GetMainElement();
  ASPx.SetElementDisplay(element, true);
  this.SetLoadingPanelPosAndSize();
  this.SetLoadingDivPosAndSize();
  ASPx.GetControlCollection().AdjustControls(element);
  this.shown = true;
 },
 Show: function () {
  this.ShowInternal(null);
 },
 ShowInElement: function (htmlElement) {
  if(htmlElement)
   this.ShowInternal(htmlElement);
 },
 ShowInElementByID: function (id) {
  var htmlElement = ASPx.GetElementById(id);
  this.ShowInElement(htmlElement);
 },
 ShowAtPos: function (x, y) {
  this.ShowInternal(null, x, y);
 },
 SetText: function (text) {
  this.isTextEmpty = (text == null || text == "");
  var textLabel = this.GetTextLabel();
  if(textLabel)
   textLabel.innerHTML = this.isTextEmpty ? "&nbsp;" : text;
 },
 GetText: function () {
  return this.isTextEmpty ? "" : this.GetTextLabel().innerHTML;
 },
 Hide: function () {
  var element = this.GetMainElement();
  ASPx.SetElementDisplay(element, false);
  element = this.GetLoadingDiv();
  if(element != null) {
   ASPx.SetStyles(element, { width: 1, height: 1 });
   ASPx.SetElementDisplay(element, false);
  }
  this.ResetCurrentShowArguments();
  this.shown = false;
 },
 GetTextLabel: function () {
  return this.GetChildElement("TL");
 },
 GetVisible: function () {
  return ASPx.GetElementDisplay(this.GetMainElement());
 },
 SetVisible: function (visible) {
  if(visible && !this.IsVisible())
   this.Show();
  else if(!visible && this.IsVisible())
   this.Hide();
 },
 BrowserWindowResizeSubscriber: function () {
  return true;
 },
 OnBrowserWindowResize: function () {
  if(this.shown) {
   this.SetLoadingPanelPosAndSize();
   this.SetLoadingDivPosAndSize();
  }
 },
 ChangeTabIndexesBehindLoadingDiv: function(restore) {
  var offsetElement = this.GetCurrentoffsetElement();
  if(!this.GetLoadingDiv() || !offsetElement) return;
  var elements = restore ? this.elementsToRestoreTabIndex : ASPx.GetCanBeActiveElementsInContainer(offsetElement);
  this.elementsToRestoreTabIndex = [];
  ASPx.Data.ForEach(elements, function(element) {
   var manager = ASPx.ControlTabIndexManager.getInstance();
   if(restore)
    manager.restoreTabIndexAttribute(element, this.GetMainElement().id);
   else {
    this.elementsToRestoreTabIndex.push(element);
    manager.changeTabIndexAttribute(element, this.GetMainElement().id);
   }
  }.aspxBind(this));
 }
});
ASPxClientLoadingPanel.Cast = ASPxClientControl.Cast;
window.ASPxClientLoadingPanel = ASPxClientLoadingPanel;
})();
